/********************************************************************
 * cam6.c        20-FEB-1992             Y.Takeuchi                 *
 *                                                                  *
 * K2917 list processing test program                               *
 ********************************************************************/
#include    <stdio.h>
#include    <string.h>
#include    "camlib.h"

#define D_size     20240
#define L_size     1024
#define DEFNAME    "cam6.obj"


main(argc, argv)
int argc;
char *argv[];
{
    unsigned short list[L_size];
    int data[D_size];
    unsigned short *usp = (unsigned short *)data;
    struct cc_iosb iosb;
    register int status;
    int i, lenlis;
    char filename[33];

/* read options */
    strcpy(filename, (argc > 1) ? argv[1] : DEFNAME);

/* Initialize data buffer */    
    for(i = 0; i < D_size; i++)
        usp[i] = 0;


/* Open */
    if (CAMOPN()) {
	printf("Open error!\n");
        exit(1);
    }
    CGENC();
    CGENZ();
    CREMI();
    CKINIT();


/* read camac list */
    status = CRLIST(filename, list, L_size, &lenlis, &i);
    printf(" list length = %d\n", lenlis);
    if (status) {
	printf("Read list error!\n");
        exit(status);
    }

/* install the list to K2917 */
    status = CKADD("test1", list, lenlis);
    if (status) {
	printf("Load list error!\n");
        exit(status);
    }

/* Execute */
    printf(" Now execute %s ...\n", filename);
    CKEXEC("test1", data, D_size, &iosb);
    printf("\n");

/* Dump buffer */
    for(i = 0; i < 10; i++)
        printf("data[%3d]=0x%8x %10u  usp[%3d]=0x%4x %5d  usp[%3d]=0x%4x %5d\n",
	       i, data[i], data[i], i*2, usp[i*2], usp[i*2], i*2+1, usp[i*2+1], usp[i*2+1]);
    printf("\n");

/* save to file */
    CKSAVE("cam6.klist");

/* Close */
    CAMCLS();

    return 0;
}
