/********************************************************************
 *                                                                  *
 * map.c           30-JUL-1991             Y.Takeuchi               *
 *                                                                  *
 * VME mapping sample                                               *
 *                                                                  *
 * compile: cc -O -o map map.c                                      *
 * usage:   map [16|24|32 [b|w [modify?]]]                          *
 ********************************************************************/
#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <sbusdev/sfvmereg.h>

#define SIZE 0x800000
#define BASE 0

#define A16_SIZE 0x10000
#define A16_BASE 0x000

main(argc, argv)
int argc;
char *argv[];
{
    int i, a, start_addr, fd, flag, dat;
    unsigned char *vaddr_vme;
    caddr_t vaddr;
    char *b_w;

    start_addr = 0;

/* read option */
    a    = (argc > 1) ? atoi(argv[1]) : 16;
    b_w  = (argc > 2) ? argv[2] : "b";
    flag = (argc > 3) ? 1 : 0;

/* open and map VME address space */
    switch (a) {
      case 16:
	fd = open("/dev/sfvme16D16", O_RDWR);
        ioctl(fd, SFVME_SET, &start_addr);
	vaddr = mmap((caddr_t)0, A16_SIZE, PROT_READ | PROT_WRITE,
                      MAP_SHARED, fd, A16_BASE);
	break;

      case 24:
	fd = open("/dev/sfvme24D16", O_RDWR);
        ioctl(fd, SFVME_SET, &start_addr);
	vaddr = mmap((caddr_t)0, SIZE, PROT_READ | PROT_WRITE,
                      MAP_SHARED, fd, BASE);
	break;

      case 32:
	fd = open("/dev/sfvme32D16", O_RDWR);
        ioctl(fd, SFVME_SET, &start_addr);
	vaddr = mmap((caddr_t)0, SIZE, PROT_READ | PROT_WRITE,
                      MAP_SHARED, fd, BASE);
	break;

      default:
	vaddr = (caddr_t)-1;
	break;
    }

    if (vaddr != (caddr_t)-1) {
	vaddr_vme = (unsigned char *)vaddr;
    }
    else {
	printf("ERROR!!\n");
	exit(1);
    }

/* LOOP */
    for (;;) {
	printf("\naddress(hex)>");
	scanf("%x", &i);
	if (b_w[0] == 'b') { 
	    printf("    vmeA%2dD16[0x%08X]: 0x%02x(B)\n",
		   a, i, *(vaddr_vme + i));
	    if (flag == 1) {
		printf("data   (hex)>");
		scanf("%x", &dat);
		*(vaddr_vme + i) = (unsigned char)dat;
		printf("    vmeA%2dD16[0x%08X]: 0x%02x(B)\n",
		       a, i, *(vaddr_vme + i));
	    }
	}
	if (b_w[0] == 'w') {
	    printf("    vmeA%2dD16[0x%08X]: 0x%04x(W)\n",
	       a, i, *(unsigned short *)(vaddr_vme + i));
	    if (flag == 1) {
		printf("data   (hex)>");
		scanf("%x", &dat);
		*(unsigned short *)(vaddr_vme + i) = (unsigned short)dat;
		printf("    vmeA%2dD16[0x%08X]: 0x%04x(W)\n",
		       a, i, *(unsigned short *)(vaddr_vme + i));
	    }
	}
    }
}


